void digit(int dig)
{
    int d7=dig & 0x7f;

	s_SevSeg += String(dig, HEX)+" ";
	if(dig>127)     {s_DMM += "."; }	
	if(d7==0)       {s_DMM += " "; return;}
	if(d7==0x7d)    {s_DMM += "0"; return;}
	if(d7==0x05)    {s_DMM += "1"; return;}
	if(d7==0x5b)    {s_DMM += "2"; return;}
	if(d7==0x1f)    {s_DMM += "3"; return;}
	if(d7==0x27)    {s_DMM += "4"; return;}
	if(d7==0x3e)    {s_DMM += "5"; return;}
	if(d7==0x7e)    {s_DMM += "6"; return;}
	if(d7==0x15)    {s_DMM += "7"; return;}
	if(d7==0x7f)    {s_DMM += "8"; return;}
	if(d7==0x3f)    {s_DMM += "9"; return;}
	if(d7==0x77)    {s_DMM += "A"; return;}
	if(d7==0x4c)    {s_DMM += "u"; return;}
	if(d7==0x6a)    {s_DMM += "t"; return;}
	if(d7==0x4e)    {s_DMM += "o"; return;}
	if(d7==0x68)    {s_DMM += "L"; return;}
	s_DMM += "_"+String(d7,HEX)+"_";
}

void decode_DMM(int ai_DMM[10])
{
    s_DMM=""; s_SevSeg=""; s_OPT=""; s_UNIT=""; s_PRE="";
    digit(16*(ai_DMM[3]%16)+ai_DMM[4]/16);
    digit(16*(ai_DMM[4]%16)+ai_DMM[5]/16);
    digit(16*(ai_DMM[5]%16)+ai_DMM[6]/16);
    digit(16*(ai_DMM[6]%16)+ai_DMM[7]/16);

    ////if(ai_DMM[10] & 0x80)    {s_UNIT+="AUTO ";  } 

    if(ai_DMM[3] & 0x08)    {s_DMM[0]='-'; } 

    ////if(ai_DMM[3] & 0x10)    {s_UNIT+="B ";  } 

    if(ai_DMM[3] & 0x40)    {s_OPT+="REL ";  } 
    if(ai_DMM[8] & 0x80)    {s_OPT+="MAX ";  } 
    if(ai_DMM[8] & 0x40)    {s_OPT+="MIN ";  } 
    if(ai_DMM[7] & 0x08)    {s_OPT+="HLD ";  } 

    if(ai_DMM[9] & 0x04)    {s_UNIT+="m";   }
    if(ai_DMM[9] & 0x08)    {s_UNIT+="V";   }
    if(ai_DMM[9] & 0x10)    {s_UNIT+="M";   }
    if(ai_DMM[9] & 0x20)    {s_UNIT+="k";   }
    if(ai_DMM[9] & 0x40)    {s_UNIT+="Ohm"; }

    if(ai_DMM[10] & 0x20)   {s_UNIT+="u";   }
    if(ai_DMM[10] & 0x10)   {s_UNIT+="m";   }
    if(ai_DMM[9] & 0x01)    {s_UNIT+="A";   }

    if(ai_DMM[8] & 0x01)    {s_UNIT+="n";  }
    if(ai_DMM[8] & 0x04)    {s_UNIT+="u";  }
    if(ai_DMM[8] & 0x02)    {s_UNIT+="m";  }
    if(ai_DMM[8] & 0x08)    {s_UNIT+="F";  }

    if(ai_DMM[9] & 0x02)    {s_UNIT+=" DC";  }
    if(ai_DMM[8] & 0x10)    {s_UNIT+=" AC";  }
    if(ai_DMM[8] & 0x20)    {s_UNIT+="%";  }
    if(ai_DMM[9] & 0x80)    {s_UNIT+="Hz";   }  
    if(ai_DMM[7] & 0x01)    {s_UNIT+=" D";   }  

    if(ai_DMM[7] & 0x04)    {s_UNIT+="\xC2\xB0""F";  }
    if(ai_DMM[7] & 0x02)    {s_UNIT+="\xC2\xB0""C";  }

    if(s_DMM=="Auto")       {s_PRE+="";}
}

int  msb(int lsb)
{
	int mm=128, ml=1, b=0; 
	for (int i=0; i<8; i++)
    {
        if((lsb & mm) == mm)
            {   b+=ml;  } 
        mm=mm/2; 
        ml=ml*2;
    } 
	return b;
}

/*
void print_binary(int v, int num_places)
{
    int mask=0, n;

    for (n=1; n<=num_places; n++)
        {   mask = (mask << 1) | 0x0001;    }

    v = v & mask;  // truncate v to specified number of places

    while (num_places)
    {
        if (v & (0x0001 << (num_places-1)))
            {   Serial.print("1");  }
        else
            {   Serial.print("0");  }

        --num_places;
        if(((num_places%4) == 0) && (num_places != 0))
            {   Serial.print("_");  }
    }
}
*/
